<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwDevice: fwDeviceFrontEndConfigFile.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwDevice
   &#160;<span id="projectnumber">8.4.1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('fwDeviceFrontEndConfigFile_8ctl.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">fwDeviceFrontEndConfigFile.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:a431ebdfffe57877ed802452810de17d7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html#a431ebdfffe57877ed802452810de17d7">fwDeviceFrontEndConfigFile_CreateContents</a> (string dpName, string &amp;fileContents, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a431ebdfffe57877ed802452810de17d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a019aa4a5d9b7eb5b9c424993f85a15a6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html#a019aa4a5d9b7eb5b9c424993f85a15a6">fwDeviceFrontEndConfigFile_GetBranchRecursive</a> (string dpName, unsigned hierarchyLevel, dyn_dyn_string &amp;hierarchyData, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a019aa4a5d9b7eb5b9c424993f85a15a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a331225386f625ccceada4b905712763c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html#a331225386f625ccceada4b905712763c">fwDeviceFrontEndConfigFile_ProcessEntry</a> (string deviceDpName, string rawEntry, string &amp;processedEntry, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a331225386f625ccceada4b905712763c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b3aeda0012aec5893bb6cddd8993671"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html#a8b3aeda0012aec5893bb6cddd8993671">fwDeviceFrontEndConfigFile_GetDpTypeTag</a> (string deviceDpType, int tagType, string &amp;configEntry, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a8b3aeda0012aec5893bb6cddd8993671"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6731d76ab809e7e8c421a7b6bab0912f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html#a6731d76ab809e7e8c421a7b6bab0912f">fwDeviceFrontEndConfigFile_GetDeviceTag</a> (dyn_string device, int tagType, string &amp;configEntry, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a6731d76ab809e7e8c421a7b6bab0912f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>NOTE: This file is not automatically loaded by fwCore.ctl and needs to be loaded explicitely, if needed</p>
<p>This library contains function associated with the creation of front end config files, using the framework hierarchy and the data stored in the device definitions.</p>
<dl class="section user"><dt>Creation Date</dt><dd>31/10/03</dd></dl>
<dl class="section user"><dt>Modification History</dt><dd></dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>WARNING: the functions use the dpGet or dpSetWait, problems may occur when using these functions in a working function called by a PVSS (dpConnect) or in a calling function</dd></dl>
<dl class="section author"><dt>Author</dt><dd>Oliver Holme (IT-CO) </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a431ebdfffe57877ed802452810de17d7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwDeviceFrontEndConfigFile_CreateContents </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dpName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>fileContents</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Creates a string containing the required contents of a front end config file.  The string can be written directly
</pre><p> to a file. The file is generated by moving down the hierarchy from a given starting point. The file entries for each device found are read from the device definitions and appended to the contents of the file.</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dpName</td><td>the name of the dp at the top of the hierarchy from which to make the config file. </td></tr>
    <tr><td class="paramname">fileContents</td><td>the contents of the file is returned here </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>details of any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a019aa4a5d9b7eb5b9c424993f85a15a6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwDeviceFrontEndConfigFile_GetBranchRecursive </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dpName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>hierarchyLevel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_string &amp;&#160;</td>
          <td class="paramname"><em>hierarchyData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Recursive function for finding details of the devices below a given device in the hierarchy
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dpName</td><td>the name of the dp from which to find the devices below. </td></tr>
    <tr><td class="paramname">hierarchyLevel</td><td>an unsigned giving the starting hierarchy level of dpName devices deeper in the hierarchy are given number relative to this starting number Note: this value can be chosen arbitrarily in any situation, but the most likely setting is 1 </td></tr>
    <tr><td class="paramname">hierarchyData</td><td>1- The dpNames of the dps in the hierarchy below dpName (including dpName) 2- The dptypes of the dps listed in 1 3- An unsigned representing the hierarhcy level of the dps listed in 1 higher values represent devices deeper in the hierarchy eg. children of dpName will have a value of hierarchyLevel+1 </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>details of any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a331225386f625ccceada4b905712763c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwDeviceFrontEndConfigFile_ProcessEntry </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceDpName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>rawEntry</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>processedEntry</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Function to process the config file entries read from the device definitions.
</pre><p> Substitutions are made as with address templates eg. name1% etc.. In addition dpe:&lt;dpElement&gt;% is substituted with the value from dpElement eg. dpe:.Settings.BaudRate% might be replaced with 125000</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deviceDpName</td><td>the name of the dp for which to process the given entry text. </td></tr>
    <tr><td class="paramname">rawEntry</td><td>the raw entry read from the device definitions </td></tr>
    <tr><td class="paramname">processedEntry</td><td>the processed entry is returned here, ready to be inserted in the config file </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>details of any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8b3aeda0012aec5893bb6cddd8993671"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwDeviceFrontEndConfigFile_GetDpTypeTag </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceDpType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tagType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>configEntry</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">DEPRECATED - Function to read the config file tags from the device definitions for a specific device type
</pre><p> DEPRECRATED - Please use fwDeviceFrontEndConfigFile_GetDeviceTag instead </p>

</div>
</div>
<a class="anchor" id="a6731d76ab809e7e8c421a7b6bab0912f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwDeviceFrontEndConfigFile_GetDeviceTag </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>device</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tagType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>configEntry</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Function to read the config file tags from the model or device definitions for a specific device
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>VISION, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">device</td><td>the device object, must contains at least the dpName </td></tr>
    <tr><td class="paramname">tagType</td><td>fwDeviceFrontEndConfigFile_OPENING_TAG to get opening tags fwDeviceFrontEndConfigFile_CLOSING_TAG to get closing tags </td></tr>
    <tr><td class="paramname">configEntry</td><td>the contents of the relevant dyn_string in the device definitions returned as a single string </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>details of any exceptions are returned here </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwDeviceFrontEndConfigFile_8ctl.html">fwDeviceFrontEndConfigFile.ctl</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
